#ifndef distort_h
#define distort_h

extern "C"
{
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include "./Key.h"
#include "NCCAPixmap.h"
#include <PixFileIO.h>
#include <Windowing.h>
}


void bobbins(void);                                                                 /* input function*/
void do_whole_image(float a1,float a2, float pppw, float ppph, float pppm);                                                          /* goes through all pixels*/
void Conv_to_polar(float *a, float *b ,float *p_angle, float *p_dist, float, float,float );                  /*converts pixel into polar 0-1 value */
void use_y_find_t(float *pdist, float v1y, float v2y,float v3y, float *found_t);    /* takes polar and converts to t value on graph*/
void use_found_t(float *found_t,float v1x, float v2x,float v3x,float *found_x);     /*takes t value and returns x value*/
void polar_to_xy(float *p_angle,float *found_x, int, float *p , float *q);
float lerp_t( int max, float value);                                                /* finds t from 3 values*/
float lerp( float a, float b, float t);                                             /* finds v from 2 values and t */

/*##################*********************  function definitions *****************************########*/

int no_im =1, ren = 0 , pla = 0, use_i =0, save_single =0;
float polmax = 0.50, pph =0.50, ppw =0.50, pos =0.50;
char inputi[100]= {"face.tif"};
char outputi[100]= {"out_image.tif"};
char sini[100]= {"run2.0001.tif"};
char souti[100]= {"N_seq"};
    char temp2[100];
static int inframe = 0;
void do_whole_image(float a1, float a2, float pppw, float ppph, float pppm)
{
  int pict_half_h, pict_half_w , polar_max, positionx, positiony,tc ;
  float angle=0, dist=0, tval=0, xval=0,i,j,p,q, n, l ; 
    char temp[100]; 

tc =0;
    static int donesf=0;     
  static int doneInit=0;


  NCCAPixmap  outputPixmap;
static NCCAPixmap inputPixmap ;
  NCCAPixel   currentPixelValue;
  static Window w;

if (no_im == 1)
{  
 if(!donesf)
      {
        while(sini[tc] !='.')
      {
    temp2[tc] = sini[tc];
       tc++;
       }
      temp2[tc] = '\0';
	donesf = 1;

       }
if (use_i == 0)
{
   if(!doneInit)
	{
        inputPixmap = loadPixmap(inputi);
		if(inputPixmap.data==NULL)
			return;

   	Screen_Init();
 	w = Window_Init(inputPixmap.height,inputPixmap.width,"distorted",2);
	doneInit=1;
	}
}
if (use_i == 1)
{
   if(!doneInit)
	{
        inputPixmap = loadPixmap(sini);
  	Screen_Init();
  	w = Window_Init(inputPixmap.height,inputPixmap.width,"distorted",2);
	doneInit=1;
	}
}
if (use_i==1)
{
  
 

sprintf(sini,"%s.%04d.tif",temp2,inframe);

inputPixmap = loadPixmap(sini);
}
inframe++;

outputPixmap = newPixmap(inputPixmap.width,inputPixmap.height,3,8);

  pict_half_h =   inputPixmap.height*ppph;                                                 /*polar 0 in height co ords*/
  pict_half_w =   inputPixmap.width*pppw;                                                   /*polar 0 in width co ords*/
  polar_max   =  inputPixmap.height*pppm;
positionx = inputPixmap.width*pppw;
positiony = inputPixmap.height*ppph;
	for (i=0.5; i<inputPixmap.height; i++)
		{
		 for (j=0.5; j<inputPixmap.width; j++)
			{               
		      Conv_to_polar( &i,&j,&angle, &dist, pict_half_h,pict_half_w,polar_max );  /*converts pixel into polar 0-1 value */
			if (dist <=1.0)                                                            /* if below are affected*/
			  {
		          use_y_find_t(&dist, 0.0, a2, 1.0, &tval);                    /* takes polar and converts to value on graph*/
			  use_found_t(&tval, 0.0, a1, 1.0,&xval);                     /*takes t value and returns x value*/
		          polar_to_xy(&angle,&xval, polar_max, &p, &q);
				n= p+positiony;
				l= q+positionx; 
               				if (a1==0.5 && a2==0.5)
                          			{
                         			currentPixelValue = getAAPixel(inputPixmap, i, j);
                          			}
                        		else  
						{
                          			currentPixelValue = getAAPixel(inputPixmap, n, l);
                          			}
			      	setPixelColour(outputPixmap, i, j, currentPixelValue);
			  }
			else if (dist>1.0)                                                  
				{		
                                currentPixelValue = getAAPixel(inputPixmap, i, j);
			        setPixelColour(outputPixmap, i, j, currentPixelValue);
				}
			}
		}
	Screen_Draw(w,outputPixmap);
	
	/*destroyPixmap(inputPixmap);*/
	/*destroyPixmap(outputPixmap);*/
   if(save_single ==1)
	{
	
  	savePixmap( outputPixmap, outputi);
  	save_single=0;
	}


if (ren == 1)
{
sprintf(temp,"%s.%04d.tif",souti,inframe);
savePixmap( outputPixmap,temp);
}

destroyPixmap(outputPixmap);
}
}

  



void Conv_to_polar( float *a, float *b, float *p_angle, float *p_dist, float phh, float phw, float pm )
{
  float x_from_c = *a - phh;
  float y_from_c = *b - phw;
  float  hyp;

  hyp = sqrt((x_from_c*x_from_c)+(y_from_c*y_from_c));
  *p_dist = lerp_t(pm, hyp);
  *p_angle =atan2(y_from_c,x_from_c);               /* returns angle in radians */
  
}



float lerp_t( int max, float value)
{
 return value/ max;
}


void use_y_find_t(float *pdist, float v1y, float v2y,float v3y, float *found_t) 
{
 float a, b, c, d;
    a= (v1y - (2*v2y) + v3y);                                             /* -1 */
    b= (-1*(-2*v1y))  + (2*v2y);                                          /* 2 */
    c= (v1y-*pdist);                                                      /*whatever pdist is*/
    d= sqrt((b*b) - (4*(a*c)));                                           /*sqare vales*/
  if (d>0)                                                                /*if d geater than 0 add*/
    {
     *found_t = ((-1*b) + d   )  / (2*a);
    }
  else									/*if d geater than 0 subtract*/
    {
     *found_t = ((-1*b) - d   )  / (2*a);
    }
}


void use_found_t(float *found_t,float v1x, float v2x,float v3x,float *found_x)
{
float v1_v2, v2_v3;
v1_v2 = lerp(v1x, v2x, *found_t);
v2_v3 = lerp(v2x, v3x, *found_t);
*found_x = lerp(v1_v2, v2_v3, *found_t);
}


float lerp( float a, float b, float t)
{
  return a + (b - a)*t;
}


void polar_to_xy(float *p_angle,float *found_x, int pm, float *p, float *q)
{
float non_polar;
 non_polar = pm *(*found_x);
*p = non_polar * cos(*p_angle);                        /* find more out about value from atan2 first*/
*q = non_polar * sin(*p_angle);
}

#endif
